{*********************************************************}
{*		    MROUNIT1.PAS 1.00			 *}
{*	  Copyright (c) Tamarack Associates 1995.	 *}
{*		   All rights reserved. 		 *}
{*********************************************************}

unit MROUnit1;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, DB, StdCtrls, Mask, ExtCtrls, DBTables,
  Grids, DBGrids, taDBMRO, DBCtrls, Tabs;

type
  TForm1 = class(TForm)
    TabSet1: TTabSet;
    Notebook1: TNotebook;
    Panel1: TPanel;
    DBText1: TDBText;
    Label1: TLabel;
    Label2: TLabel;
    DBEdit1: TDBEdit;
    DBEdit2: TDBEdit;
    DBEdit3: TDBEdit;
    DBEdit5: TDBEdit;
    DBEdit6: TDBEdit;
    DBEdit7: TDBEdit;
    DBEdit8: TDBEdit;
    DBEdit9: TDBEdit;
    DBEdit4: TDBEdit;
    DBEdit10: TDBEdit;
    taDBMRO1: TtaDBMRO;
    Panel2: TPanel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Panel3: TPanel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    GroupBox1: TGroupBox;
    IndicatorCheckBox: TCheckBox;
    RowLinesCheckBox: TCheckBox;
    OnDrawBackgroundCheckBox: TCheckBox;
    MROColorCheckBox: TCheckBox;
    TitlesCheckBox: TCheckBox;
    AutoHeightCheckBox: TCheckBox;
    AutoWidthCheckBox: TCheckBox;
    UseColorCheckBox: TCheckBox;
    UseFontCheckBox: TCheckBox;
    DBNavigator1: TDBNavigator;
    DataSource1: TDataSource;
    Table1: TTable;
    Table1CustNo: TFloatField;
    Table1Company: TStringField;
    Table1Addr1: TStringField;
    Table1Addr2: TStringField;
    Table1City: TStringField;
    Table1State: TStringField;
    Table1Zip: TStringField;
    Table1Country: TStringField;
    Table1Phone: TStringField;
    Table1FAX: TStringField;
    Table1TaxRate: TFloatField;
    Table1Contact: TStringField;
    Table1LastInvoiceDate: TDateTimeField;
    Panel4: TPanel;
    Label17: TLabel;
    Label18: TLabel;
    Label19: TLabel;
    Memo1: TMemo;
    Panel5: TPanel;
    TabCheckBox: TCheckBox;
    Bevel1: TBevel;
    Label3: TLabel;
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure IndicatorCheckBoxClick(Sender: TObject);
    procedure RowLinesCheckBoxClick(Sender: TObject);
    procedure taDBMRO1DrawBackground(Sender: TObject; Control: TControl;
      const CellRect: TRect);
    procedure OnDrawBackgroundCheckBoxClick(Sender: TObject);
    procedure MROColorCheckBoxClick(Sender: TObject);
    procedure TitlesCheckBoxClick(Sender: TObject);
    procedure AutoWidthCheckBoxClick(Sender: TObject);
    procedure AutoHeightCheckBoxClick(Sender: TObject);
    procedure UseColorCheckBoxClick(Sender: TObject);
    procedure UseFontCheckBoxClick(Sender: TObject);
    procedure TabSet1Change(Sender: TObject; NewTab: Integer;
      var AllowChange: Boolean);
    procedure DBEdit10Exit(Sender: TObject);
    procedure DBEdit1Exit(Sender: TObject);
  private
    { Private declarations }
    PROCEDURE WMParentNotify(VAR Msg : TWMParentNotify) ; MESSAGE WM_PARENTNOTIFY;
  protected
    { Protected declarations }
    PROCEDURE ActiveChanged ; OVERRIDE;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
 taDBMRO1.FormKeyDown(ActiveControl,Key,Shift)
end;

{* Routine needed to implement Tabbing to next/prior record *}

PROCEDURE TForm1.WMParentNotify(VAR Msg : TWMParentNotify);
BEGIN
 taDBMRO1.MonitorFocus(Msg.Event);
 INHERITED
END;

{* Routine needed to implement Tabbing to next/prior record *}

PROCEDURE TForm1.ActiveChanged;
BEGIN
 taDBMRO1.MonitorFocus(WM_SETFOCUS);
 {* The inherited routine is empty, so no real need to call it *}
 INHERITED ActiveChanged
END;

procedure TForm1.IndicatorCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  BEGIN
   IF dgIndicator IN Options THEN
    Options := Options - [dgIndicator]
   ELSE
    Options := Options + [dgIndicator]
  END
end;

procedure TForm1.RowLinesCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  IF dgRowLines IN Options THEN
   Options := Options - [dgRowLines]
  ELSE
   Options := Options + [dgRowLines]
end;

procedure TForm1.taDBMRO1DrawBackground(Sender: TObject; Control: TControl;
  const CellRect: TRect);
begin
 WITH taDBMRO1.Canvas DO
  BEGIN
   Brush.Color := clBtnFace;
   FillRect(CellRect)
  END
end;

procedure TForm1.OnDrawBackgroundCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  BEGIN
   IF (Sender AS TCheckBox).Checked THEN
    OnDrawBackground := taDBMRO1DrawBackground
   ELSE OnDrawBackground := NIL;
   Invalidate
  END
end;

procedure TForm1.TitlesCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  IF dgTitles IN Options THEN
   Options := Options - [dgTitles]
  ELSE
   BEGIN
    Options := Options + [dgTitles];
   END
end;

procedure TForm1.AutoHeightCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  BEGIN
   AutoHeight := NOT AutoHeight;
   IF NOT AutoHeight THEN Height := Height + 26
  END
end;

procedure TForm1.AutoWidthCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  BEGIN
   AutoWidth := NOT AutoWidth;
   IF NOT AutoWidth THEN Width := Width + 5
  END
end;

procedure TForm1.MROColorCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  IF Color = RecordPanel.Color THEN Color := clYellow
  ELSE Color := RecordPanel.Color
end;

procedure TForm1.UseColorCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  UseColor := NOT UseColor;
end;

procedure TForm1.UseFontCheckBoxClick(Sender: TObject);
begin
 WITH taDBMRO1 DO
  UseFont := NOT UseFont
end;

procedure TForm1.TabSet1Change(Sender: TObject; NewTab: Integer;
  var AllowChange: Boolean);
begin
 AllowChange := TRUE;
 CASE NewTab OF
  0 : Notebook1.ActivePage := 'Introduction';
  1 : Notebook1.ActivePage := 'Demonstration';
 END
end;

{* Routine needed to implement Tabbing to next/prior record *}

procedure TForm1.DBEdit1Exit(Sender: TObject);
begin
 IF TabCheckBox.Checked THEN
  taDBMRO1.FieldOnExit(ActiveControl,UseFontCheckBox,DBEdit10,FALSE)
end;

{* Routine needed to implement Tabbing to next/prior record *}

procedure TForm1.DBEdit10Exit(Sender: TObject);
begin
 IF TabCheckBox.Checked THEN
  taDBMRO1.FieldOnExit(ActiveControl,IndicatorCheckBox,DBEdit1,TRUE)
end;

end.
